<style src="./Style.scss" lang="scss" scoped></style>
<script src="./Script.js"></script>

<template>
  <div class="m-content" style="padding-bottom: 0 !important">
    <Loading :is_loader="isLoading" :hasBg="false" />
    <div class="nt-my-job nt-scroll-primary pb-1 mb-1">
      <div class="nt-list-col">
        <div class="nt-col" v-for="(category, index) in categories" :key="index">
          <div class="nt-col-head" :style="{ 'border-top-color': category.borderColor }">
            <h3 class="nt-col-head-title">
              {{ category.name }}
              <template v-if="category.name === 'Đã hoàn thành'">
                <i
                  class="fa fa-info nt-col-head-title-info"
                  data-toggle="m-tooltip"
                  data-original-title="
                    <div style='margin-bottom: 5px;'>Chỉ những công việc trong cột này mới được đánh dấu là hoàn thành.</div>
                    <div style='display: flex; width: 100%; align-items: center; margin-bottom: 5px;'>
                      <span style='float: left; width: 45px;'>Ví dụ: </span>
                      <span style='float: left; width: 159px;'><img style='max-width: 100%;' src='./assets/img/task-category-info.png' /></span>
                    </div>
                    "
                  data-html="true"
                  @mouseover="reloadTooltip()"
                ></i>
              </template>
            </h3>
            <div class="nt-col-head-count">{{ category.tasks && category.tasks.length }} công việc</div>
          </div>
          <div class="position-relative d-flex flex-column scroll-box">
            <NoResult
              v-if="!category.isLoading && !category.tasks.length"
              class="centering w-100"
              icon="icon icon-audit"
              message="Hiện tại bạn chưa có công việc nào!"
            />
            <Loading :is_loader="category.isLoading" />
            <draggable
              class="nt-col-body nt-scroll-primary h-100"
              ghost-class="sortable-ghost"
              animation="150"
              group="myJob"
              :sort="true"
              :list="category.tasks"
              @change="onChange($event, category)"
            >
              <div
                class="nt-item position-relative"
                v-for="task in category.tasks"
                :key="task.id"
                :id="task.id"
              >
                <div @click.stop.prevent="showDetails(task, false)">
                  <Loading :is_loader="task.isLoading" />
                  <h3 class="nt-item-title d-flex justify-content-between">
                    <div class="title">{{ task.title }}</div>
                  </h3>
                  <div v-if="task.deadline" class="nt-item-time">
                    <i
                      class="icon icon-calendar"
                      :class="{ 'd-none': !isShowExpire(task.deadline) }"
                    ></i>
                    <div class="nt-item-expire" :class="{ 'd-none': isShowExpire(task.deadline) }">
                      <i class="far fa-clock"></i>
                    </div>
                    {{ getDate(task.deadline) | formatDateTime }} - {{ getTime(task.deadline) }}
                  </div>
                </div>
                <div class="actions">
                  <a
                    href="#"
                    aria-expanded="true"
                    aria-haspopup="true"
                    data-toggle="dropdown"
                    class="item-dropdown"
                  >
                    <i class="la la-ellipsis-v"></i>
                  </a>
                  <div class="dropdown-menu nt-dropdown-menu">
                    <a href="#" @click.stop.prevent="showDetails(task, true)" class="dropdown-item">
                      <i class="icon icon-edit"></i>
                      Chỉnh sửa
                    </a>
                    <a href="#" @click.stop.prevent="onDeleteTask(task)" class="dropdown-item">
                      <i class="icon icon-trash-1"></i>
                      Xóa
                    </a>
                  </div>
                </div>
              </div>
            </draggable>
            <button
              v-if="category.isAllowAdd"
              class="btn btn-block btn-add p-0 d-flex align-items-center justify-content-center"
              data-toggle="modal"
              href="#addNewMyJob"
            >
              <i class="icon icon-plus"></i>
              Thêm công việc
            </button>
          </div>
        </div>
      </div>
    </div>
    <Details
      @onDeleteTaskSuccess="onDeleteTaskSuccess"
      @cancelOnUpdateTask="cancelOnUpdateTask"
      @onUpdateTask="onUpdateTask"
    />
    <AddNew :category="todoCategory" @onAddTask="onAddTask($event)" />
  </div>
</template>
